/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.AttendanceTotalAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.KintaiApprovalPart;
import jp.mosp.common.part.KintaiCommonPart;

import jp.mosp.kintai.action.AttendanceListAction;
import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.vo.AttendanceStartCardVo;

public class AttendanceStartCardAction extends AttendanceTotalAction {

	// コマンド
	public static final String CMD_START_CARD_SHOW		= "K1100";
	public static final String CMD_START_CARD_SELECT		= "K1101";
	private static final String CMD_START_CARD_REGIST		= "K1102";
	private static final String CMD_START_CARD_DELETE		= "K1103";

	/**
	 * コンストラクタ
	 */
	public AttendanceStartCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		AttendanceStartCardVo vo;
		vo = (AttendanceStartCardVo)getStoredVo(CommonConst.VO_ATTENDANCE_START_CARD);
		if (vo == null) {
			vo = new AttendanceStartCardVo();
		}
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.clearMessage();
		vo.clearErrField();
		storeVo(CommonConst.VO_ATTENDANCE_START_CARD, vo);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		MSyukkinboDto dto;
		Object objDto = session.getAttribute(MospConst.ATT_DTO);
		dto = objDto instanceof MSyukkinboDto ? (MSyukkinboDto)objDto : null;
		// DBコネクション取得
		getConnection();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 勤務形態プルダウン
		vo.aryPltWorkType = getWorkTypeArrayWithWeekHoliday();
		// 出勤時半休区分プルダウン
		vo.aryPltHalfHoliday = getMosPCodeArray(CommonConst.TID_HALF_HOLIDAY_TYPE);
		// 休出区分プルダウン
		vo.aryPltWorkOnHoliday = getMosPCodeArray(CommonConst.TID_WORK_ON_HOLIDAY_TYPE);
		// 遅刻理由プルダウン
		vo.aryPltLateReason = getReasonCodeArray(CommonConst.TID_LATE_REASON);
		// 遅刻証明書プルダウン
		vo.aryPltLateCertificate = getMosPCodeArray(CommonConst.TID_LATE_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_START_CARD_SHOW)) {
			// 表示項目の初期化
			vo.initFields();
			// 表示、登録の準備
			setAttendanceInfo(vo);
			// 出勤ボタンにコマンドをセット
			vo.setCmdStartButton(CMD_START_CARD_SHOW);
			// 休暇ボタンにコマンドをセット
			vo.setCmdHolidayButton(AttendanceHolidayCardAction.CMD_HOLIDAY_CARD_SHOW);
			// 表示モードセット
			setMode(vo, dto);
		} else if (cmd.equals(CMD_START_CARD_SELECT)) {
			vo.setParams(request);
			// 出勤検索
			dto = searchAttendance(vo);
			// 出勤ボタンにコマンドをセット
			vo.setCmdStartButton(CMD_START_CARD_SELECT);
			// 退勤ボタンにコマンドをセット
			vo.setCmdQuitButton(AttendanceQuitCardAction.CMD_QUIT_CARD_SHOW);
			// MenuVoに選択コマンドをセット
			vo.setHidSelectCmd(CMD_START_CARD_SELECT);
			// 残業申請情報設定
			setOverTimeRequestInfo(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_START_CARD_REGIST)) {
			vo.setParams(request);
			// 登録
			dto = registAttendance(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		} else if (cmd.equals(CMD_START_CARD_DELETE)) {
			vo.setParams(request);
			// 削除
			dto = delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
		// 再検索用MenuVoの保存
		setStoreAttendanceMenuVo(vo);
	}

	/**
	 * 出勤検索
	 * @param vo AttendanceCardVoインスタンス
	 * @return 取得AttendanceCardDtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto searchAttendance(AttendanceStartCardVo vo) throws Exception {
		// 勤怠検索
		MSyukkinboDto dto = getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate());
		// VOに情報を設定
		vo.setFields(dto);
		// 表示モードのセット
		setMode(vo, dto);
		return dto;
	}

	/**
	 * 出勤登録
	 * @param vo  Voインスタンス
	 * @param dto Dtoインスタンス
	 * @return 登録後再取得Dtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto registAttendance(
			AttendanceStartCardVo vo,
			MSyukkinboDto dto
	) throws Exception {
		// 勤怠検索
		MSyukkinboDto mSyukkinboDto = new MSyukkinboDto();
		if (!chkExistDto(dto)) {
			// INSERT(セッション保存DTOが存在しない場合)
			// 週休の場合
			if (KintaiCommonPart.isWeekHoliday(vo.getPltWorkType())) {
				vo.setWeekHolidayDtoFields(mSyukkinboDto);
			} else {
				vo.setDtoFields(mSyukkinboDto);
			}
			mSyukkinboDto.setSyozoku(mKihon.getSCode());
			// 自動計算
			runAutoStartCalc(mSyukkinboDto);
			// 存在チェック
			chkDuplicate(getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke()), vo);
			// 週休の場合
			if (KintaiCommonPart.isWeekHoliday(vo.getPltWorkType())) {
				// 登録
				syukkinboDao().insert(mSyukkinboDto);
			} else {
				// 登録（出勤項目のみ）
				syukkinboDao().insertStart(mSyukkinboDto);
			}
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (KintaiApprovalPart.isApproved(dto)) {
				// メッセージ設定
				request.setAttribute(MospConst.ATT_MESSAGE, 
						MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
								getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay())
						)
				);
			} else {
				// UPDATE(セッション保存DTOが存在する場合)
				mSyukkinboDto = dto;
				vo.setDtoFields(mSyukkinboDto);
				// 自動計算
				runAutoStartCalc(mSyukkinboDto);
				// 排他確認
				chkExclusive(mSyukkinboDto, getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke(), true), vo);
				// 更新（出勤項目のみ）
				syukkinboDao().updateStart(mSyukkinboDto);
			}
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke());
		chkUpdate(retDto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * 出勤項目削除
	 * @param dto
	 * @throws Exception
	 */
	private MSyukkinboDto delete(AttendanceStartCardVo vo, MSyukkinboDto dto) throws Exception {
		// データ存在確認
		chkExist(dto);
		// 承認済みの場合はメッセージ表示、削除不可
		if (KintaiApprovalPart.isApproved(dto)) {
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, 
					MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
							getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay())));
		} else {
			// 削除
			syukkinboDao().delete(dto);
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
		// コミット
		commit();
		return retDto;
	}

	/**
	 * 自動計算メソッド
	 * @param vo
	 * @param dto
	 * @throws Exception
	 */
	private void runAutoStartCalc(MSyukkinboDto dto) throws Exception {
		// 勤怠情報設定
		setCalcParam();
		// 自動計算フラグ有り且つ週休以外のみ、勤務形態から遅刻時間を計算
		if (isAutoCalc && !KintaiCommonPart.isWeekHoliday(dto)) {
			// 出勤項目の計算
			getStartCalculated(dto);
		}
	}

}
